<?php
/**d
 * @package    bitpayir payment module
 * @author     bdt team
 * @copyright  2014  bitpay.ir
 * @version    1.00
 */
if (!defined('_PS_VERSION_'))
	exit ;
class bitpayir extends PaymentModule {

	private $_html = '';
	private $_postErrors = array();

	public function __construct() {

		$this->name = 'bitpayir';
		$this->tab = 'payments_gateways';
		$this->version = '1.1';
		$this->author = 'bdt team';
		$this->currencies = true;
		$this->currencies_mode = 'radio';
		parent::__construct();
		$this->displayName = $this->l('bitpayir Payment Modlue');
		$this->description = $this->l('Online Payment With bitpay');
		$this->confirmUninstall = $this->l('Are you sure you want to delete your details?');
		if (!sizeof(Currency::checkPaymentCurrencies($this->id)))
			$this->warning = $this->l('No currency has been set for this module');
		$config = Configuration::getMultiple(array('bitpayir_API'));
		if (!isset($config['bitpayir_API']))
			$this->warning = $this->l('You have to enter your bitpay API code to use bitpayir for your online payments.');

	}

	public function install() {
		if (!parent::install() || !Configuration::updateValue('bitpayir_API', '') || !Configuration::updateValue('bitpayir_LOGO', '') || !Configuration::updateValue('bitpayir_HASH_KEY', $this->hash_key()) || !$this->registerHook('payment') || !$this->registerHook('paymentReturn'))
			return false;
		else
			return true;
	}

	public function uninstall() {
		if (!Configuration::deleteByName('bitpayir_API') || !Configuration::deleteByName('bitpayir_LOGO') || !Configuration::deleteByName('bitpayir_HASH_KEY') || !parent::uninstall())
			return false;
		else
			return true;
	}

	public function hash_key() {
		$en = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z');
		$one = rand(1, 26);
		$two = rand(1, 26);
		$three = rand(1, 26);
		return $hash = $en[$one] . rand(0, 9) . rand(0, 9) . $en[$two] . $en[$tree] . rand(0, 9) . rand(10, 99);
	}

	public function getContent() {

		if (Tools::isSubmit('bitpayir_setting')) {

			Configuration::updateValue('bitpayir_API', $_POST['bp_API']);
			Configuration::updateValue('bitpayir_LOGO', $_POST['bp_LOGO']);
			$this->_html .= '<div class="conf confirm">' . $this->l('Settings updated') . '</div>';
		}

		$this->_generateForm();
		return $this->_html;
	}

	private function _generateForm() {
		$this->_html .= '<div align="center"><form action="' . $_SERVER['REQUEST_URI'] . '" method="post">';
		$this->_html .= $this->l('Enter your API Code :') . '<br/><br/>';
		$this->_html .= '<input type="text" name="bp_API" value="' . Configuration::get('bitpayir_API') . '" ><br/><br/>';
		$this->_html .= '<input type="submit" name="bitpayir_setting"';
		$this->_html .= 'value="' . $this->l('Save it!') . '" class="button" />';
		$this->_html .= '</form><br/></div>';
	}

	public function do_payment($cart) {
		
		
		$api 	  = Configuration::get('bitpayir_API');
		$amount   = floatval(number_format($cart ->getOrderTotal(true, 3), 2, '.', ''));
		
		$orderId = $cart ->id;
		$description = 'پرداخت سفارش شماره: ' . $cart ->id;
		
		
		$currency_id = $cart->id_currency;

		foreach(Currency::getCurrencies() as $key => $currency){
			if ($currency['id_currency'] == $currency_id){
				$currency_iso_code = $currency['iso_code'];
			}
		}
		
		if ($currency_iso_code != 'IRR'){
			$amount = $amount * 10;
		}
		
		
		$hash = Configuration::get('bitpayir_HASH');
		$codeHash = md5($orderId . $amount . $hash);
		
		
		$redirect = (Configuration::get('PS_SSL_ENABLED') ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . __PS_BASE_URI__ . 'modules/bitpayir/bp.php?do=call_back&id=' . $cart ->id . '&amount=' . $amount.'&currency_id='.$currency_id.'&iso_code='.$currency_iso_code.'&hashCode='.$codeHash;
		$redirect = urlencode($redirect);
		
		$ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,"https://bitpay.ir/payment/gateway-send");
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect&description=$description");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        
		
		
		
		if ($res > 0 && is_numeric($res)) {
			Tools::redirect("https://bitpay.ir/payment/gateway-" . $res.'-get');
		} elseif ($res < 1) {
			echo $this->error($this->l('There is a problem.') . ' (' . $res . ')');
		} else {
			echo $this->error($this->l('There is a problem.'));
		}
	}

	public function error($str) {
		return '<div class="alert error">' . $str . '</div>';
	}

	public function success($str) {
		echo '<div class="conf confirm">' . $str . '</div>';
	}

	public function hookPayment($params) {
		global $smarty;
		$smarty ->assign('bitpayir_logo', Configuration::get('bitpayir_LOGO'));
		if ($this->active)
			return $this->display(__FILE__, 'bppayment.tpl');
	}

	public function hookPaymentReturn($params) {
		if ($this->active)
			return $this->display(__FILE__, 'bpconfirmation.tpl');
	}

}

// End of: bitpayir.php
?>
